// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMRBase.pas' rev: 5.00

#ifndef SMRBaseHPP
#define SMRBaseHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SMPrntr.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <SMCntrl.hpp>	// Pascal unit
#include <ComCtrls.hpp>	// Pascal unit
#include <SMRPars.hpp>	// Pascal unit
#include <SMRTypes.hpp>	// Pascal unit
#include <SMExpr.hpp>	// Pascal unit
#include <SMPWhen.hpp>	// Pascal unit
#include <PrintSM.hpp>	// Pascal unit
#include <SMRCnst.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smrbase
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMRControlResize { scrLeftTop, scrTop, scrRightTop, scrLeft, scrRight, scrLeftBottom, scrBottom, 
	scrRightBottom, scrNone };
#pragma option pop

#pragma option push -b-
enum TSMRControlState { scsNothing, scsResize, scsMove };
#pragma option pop

#pragma option push -b-
enum TSMRObjectPosition { opDesigned, opTopBand, opBottomBand, opCenterBand };
#pragma option pop

typedef TMetaClass*TSMRControlClass;

class DELPHICLASS TSMRControl;
class DELPHICLASS TSMReport;
typedef void __fastcall (__closure *TColumnEvent)(System::TObject* Sender, int Column);

typedef void __fastcall (__closure *TGenerateBeforeEvent)(System::TObject* Sender, TSMRControl* cntrl
	);

typedef void __fastcall (__closure *TGenerateAfterEvent)(System::TObject* Sender, TSMRControl* cntrl
	, bool &Abort);

#pragma option push -b-
enum TUpdateValue { uvAllBand, uvWithoutGroupFooter, uvOnlyGroupFooter, uvOnlyCustomVariables };
#pragma option pop

#pragma option push -b-
enum TSMReportState { rsNone, rsDesign, rsPrepare, rsPrint };
#pragma option pop

class DELPHICLASS TSMRBand;
#pragma option push -b-
enum TBandType { btNone, btReportTitle, btPageHeader, btColumnHeader, btGroupHeader, btDetail, btGroupFooter, 
	btColumnFooter, btPageFooter, btReportSummary, btSubDetail };
#pragma option pop

class PASCALIMPLEMENTATION TSMReport : public Printsm::TSMPrintComponent 
{
	typedef Printsm::TSMPrintComponent inherited;
	
private:
	Db::TDataSet* FDataSet;
	int intBarWidth;
	int intColumnLeft;
	int intColumnTop;
	int intColumnBottom;
	bool boolWasNewPage;
	int FStartAt;
	int FCountBy;
	int FBarNumber;
	int FColumnSpace;
	int FColumnNumber;
	TColumnEvent FBeginColumn;
	TColumnEvent FEndColumn;
	TGenerateBeforeEvent FBeforeControlPrint;
	TGenerateAfterEvent FAfterControlPrint;
	TGenerateBeforeEvent FBeforeBandPrint;
	TGenerateAfterEvent FAfterBandPrint;
	void __fastcall ResetPrintedValues(Smrtypes::TResetType RType, AnsiString strGroupName);
	Db::TDataSet* __fastcall GetDataSet(void);
	void __fastcall SetDataSet(Db::TDataSet* AValue);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	DYNAMIC void __fastcall GetChildren(Classes::TGetChildProc Proc, Classes::TComponent* Root);
	virtual void __fastcall ReadState(Classes::TReader* Reader);
	DYNAMIC Classes::TComponent* __fastcall GetChildParent(void);
	DYNAMIC Classes::TComponent* __fastcall GetChildOwner(void);
	AnsiString __fastcall GetUniqueName(AnsiString sName);
	void __fastcall UpdateCurValues(int intStartBand, int intEndBand, TUpdateValue UpdateValues);
	virtual void __fastcall PrepareReport(void);
	virtual int __fastcall GetPageNoCountBy(void);
	virtual int __fastcall GetPageNoStartAt(void);
	virtual int __fastcall GetCurColumn(void);
	virtual int __fastcall GetColumnNumber(void);
	
public:
	TSMReportState ReportState;
	Classes::TList* Bands;
	Classes::TList* DataSets;
	int intCurColumn;
	__fastcall virtual TSMReport(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMReport(void);
	void __fastcall NewReport(void);
	void __fastcall SaveReport(AnsiString FFileName);
	void __fastcall LoadReport(AnsiString FFileName);
	void __fastcall BandReOrder(void);
	int __fastcall AppendBand(TSMRBand* band, bool boolAppend);
	int __fastcall AddBand(TBandType bt, bool boolAppend);
	void __fastcall DeleteBand(int i);
	void __fastcall DeleteAllBands(void);
	void __fastcall AddGroup(int &intGroupHeader, int &intGroupFooter, bool boolNewPage, bool boolReprintHeader
		, double flLessThan, AnsiString strExpression);
	void __fastcall DeleteGroup(AnsiString strExpression);
	int __fastcall GetIndexBand(TBandType bt);
	TSMRBand* __fastcall GetBand(int i);
	TSMRControl* __fastcall GetFirstSelected(void);
	void __fastcall SelectElements(int Select);
	void __fastcall AssignGroups(bool boolClear, Classes::TStrings* sl);
	void __fastcall FillDSList(void);
	void __fastcall AssignDataSets(Classes::TStrings* sl);
	virtual void __fastcall NewPage(bool isNewBar);
	
__published:
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property int BarNumber = {read=FBarNumber, write=FBarNumber, nodefault};
	__property int ColumnSpace = {read=FColumnSpace, write=FColumnSpace, nodefault};
	__property int ColumnNumber = {read=GetColumnNumber, write=FColumnNumber, nodefault};
	__property int PageNoStartAt = {read=GetPageNoStartAt, write=FStartAt, nodefault};
	__property int PageNoCountBy = {read=GetPageNoCountBy, write=FCountBy, nodefault};
	__property Variables ;
	__property TColumnEvent OnBeginColumn = {read=FBeginColumn, write=FBeginColumn};
	__property TColumnEvent OnEndColumn = {read=FEndColumn, write=FEndColumn};
	__property TGenerateBeforeEvent BeforeControlPrint = {read=FBeforeControlPrint, write=FBeforeControlPrint
		};
	__property TGenerateAfterEvent AfterControlPrint = {read=FAfterControlPrint, write=FAfterControlPrint
		};
	__property TGenerateBeforeEvent BeforeBandPrint = {read=FBeforeBandPrint, write=FBeforeBandPrint};
	__property TGenerateAfterEvent AfterBandPrint = {read=FAfterBandPrint, write=FAfterBandPrint};
	__property AnimatedStatus ;
	__property Frame ;
	__property PrinterSetting ;
	__property Font ;
	__property OnGetVariable ;
};


class PASCALIMPLEMENTATION TSMRControl : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	Variant FPrevValue;
	Variant FCurValue;
	Smpwhen::TSMPrintWhen FSMPrintWhen;
	Smrtypes::TSMRHighLights* FHighLights;
	AnsiString FDisplayName;
	bool FSelected;
	Classes::TAlignment FAlignment;
	Printsm::TSMRFrame* FFrame;
	Graphics::TBrushStyle FBrushStyle;
	Classes::TStrings* FComments;
	TSMRObjectPosition FObjectPosition;
	Graphics::TColor FBackColor;
	Variant __fastcall GetPrevValue();
	Variant __fastcall GetCurValue();
	bool __fastcall ValueChanged(void);
	bool __fastcall GetTransparent(void);
	void __fastcall SetTransparent(bool Value);
	void __fastcall SetSelected(bool Value);
	void __fastcall SetFrame(Printsm::TSMRFrame* Value);
	void __fastcall SetDisplayName(AnsiString Value);
	void __fastcall SetComments(Classes::TStrings* Value);
	Smrtypes::TSMRHighLights* __fastcall GetHighLights(void);
	void __fastcall SetHighLights(Smrtypes::TSMRHighLights* Value);
	void __fastcall DrawDefault(Graphics::TCanvas* ACanvas, const Windows::TRect &ARect);
	void __fastcall DrawPoint(Graphics::TCanvas* ACanvas, int X, int Y);
	void __fastcall DrawSelection(Graphics::TCanvas* ACanvas, const Windows::TRect &ARect);
	int __fastcall DrawWrapText(Graphics::TCanvas* ACanvas, AnsiString Text, const Windows::TRect &ARect
		, Word Flags, int AAngle);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall ReadState(Classes::TReader* Reader);
	virtual void __fastcall SetAlignment(Classes::TAlignment Value);
	virtual void __fastcall UpdateCurValue(void);
	void __fastcall BeforeEditProperties(Smcntrl::TfrmControl* frmControl);
	void __fastcall AfterEditProperties(Smcntrl::TfrmControl* frmControl);
	
public:
	TSMReport* FSMReport;
	int StartMouseDownX;
	int StartMouseDownY;
	TSMRControlResize SMRControlResize;
	TSMRControlState SMRControlState;
	__fastcall virtual TSMRControl(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRControl(void);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	__property bool Selected = {read=FSelected, write=SetSelected, nodefault};
	__property Smpwhen::TSMPrintWhen SMPrintWhen = {read=FSMPrintWhen, write=FSMPrintWhen};
	__property Variant PrevValue = {read=GetPrevValue, write=FPrevValue};
	__property Variant CurValue = {read=GetCurValue, write=FCurValue};
	
__published:
	__property AnsiString DisplayName = {read=FDisplayName, write=SetDisplayName};
	__property Printsm::TSMRFrame* Frame = {read=FFrame, write=SetFrame};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, nodefault};
	__property bool Transparent = {read=GetTransparent, write=SetTransparent, nodefault};
	__property Graphics::TBrushStyle BrushStyle = {read=FBrushStyle, write=FBrushStyle, nodefault};
	__property Classes::TStrings* Comments = {read=FComments, write=SetComments};
	__property Smrtypes::TSMRHighLights* HighLights = {read=GetHighLights, write=SetHighLights};
	__property TSMRObjectPosition ObjectPosition = {read=FObjectPosition, write=FObjectPosition, nodefault
		};
	__property Graphics::TColor BackColor = {read=FBackColor, write=FBackColor, nodefault};
	__property Height ;
	__property Width ;
	__property Left ;
	__property Top ;
	__property Font ;
	__property Hint ;
	__property PopupMenu ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
};


class DELPHICLASS TSMRLabel;
class PASCALIMPLEMENTATION TSMRLabel : public TSMRControl 
{
	typedef TSMRControl inherited;
	
private:
	bool FWordWrap;
	int FAngle;
	bool FStretch;
	void __fastcall SetAngle(int Value);
	int __fastcall DoDrawText(Graphics::TCanvas* ACanvas, const Windows::TRect &ARect, Word Flags, AnsiString 
		Text);
	
protected:
	virtual AnsiString __fastcall GetValueForShow(const Variant &Value);
	virtual void __fastcall UpdateCurValue(void);
	
public:
	__fastcall virtual TSMRLabel(Classes::TComponent* AOwner);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property int Angle = {read=FAngle, write=SetAngle, nodefault};
	__property bool WordWrap = {read=FWordWrap, write=FWordWrap, nodefault};
	__property bool Stretch = {read=FStretch, write=FStretch, nodefault};
public:
	#pragma option push -w-inl
	/* TSMRControl.Destroy */ inline __fastcall virtual ~TSMRLabel(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRExpression;
class PASCALIMPLEMENTATION TSMRExpression : public TSMRLabel 
{
	typedef TSMRLabel inherited;
	
private:
	AnsiString FExpression;
	AnsiString FFormat;
	Smrtypes::TSMRCalculation* FCalculation;
	void __fastcall SetCalculation(Smrtypes::TSMRCalculation* Value);
	void __fastcall SetExpression(AnsiString Value);
	
protected:
	virtual AnsiString __fastcall GetValueForShow(const Variant &Value);
	virtual void __fastcall UpdateCurValue(void);
	
public:
	__fastcall virtual TSMRExpression(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRExpression(void);
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property AnsiString Expression = {read=FExpression, write=SetExpression};
	__property AnsiString Format = {read=FFormat, write=FFormat};
	__property Smrtypes::TSMRCalculation* Calculation = {read=FCalculation, write=SetCalculation};
};


class DELPHICLASS TSMRSysData;
class PASCALIMPLEMENTATION TSMRSysData : public TSMRLabel 
{
	typedef TSMRLabel inherited;
	
private:
	Smrcnst::TSMRSysDataType FSysData;
	AnsiString FFormat;
	void __fastcall SetSysData(Smrcnst::TSMRSysDataType Value);
	
protected:
	virtual AnsiString __fastcall GetValueForShow(const Variant &Value);
	virtual void __fastcall UpdateCurValue(void);
	
public:
	__fastcall virtual TSMRSysData(Classes::TComponent* AOwner);
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property Smrcnst::TSMRSysDataType SysData = {read=FSysData, write=SetSysData, nodefault};
	__property AnsiString Format = {read=FFormat, write=FFormat};
public:
	#pragma option push -w-inl
	/* TSMRControl.Destroy */ inline __fastcall virtual ~TSMRSysData(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TLineStyle { lsSingle, lsDouble };
#pragma option pop

#pragma option push -b-
enum TShapeStretch { ssNoStretch, ssTallest, ssHeight };
#pragma option pop

#pragma option push -b-
enum TShapeType { stLine, stRectangle, stEllipse };
#pragma option pop

#pragma option push -b-
enum TLineType { ltTop, ltBottom, ltLeft, ltRight, ltLeftDiagonal, ltRightDiagonal, ltHCenter, ltVCenter 
	};
#pragma option pop

#pragma option push -b-
enum TRectangleType { rtRectangle, rtRoundRect, rtSquare, rtRoundSquare };
#pragma option pop

#pragma option push -b-
enum TEllipseType { etEllipse, etCircle };
#pragma option pop

class DELPHICLASS TSMRShape;
class PASCALIMPLEMENTATION TSMRShape : public TSMRControl 
{
	typedef TSMRControl inherited;
	
private:
	TShapeStretch FStretch;
	TLineType FLineType;
	TRectangleType FRectangleType;
	TEllipseType FEllipseType;
	TLineStyle FLineStyle;
	void __fastcall DrawLine(Graphics::TCanvas* ACanvas, const Windows::TRect &BRect);
	
protected:
	TShapeType ShapeType;
	__property TLineType LineType = {read=FLineType, write=FLineType, nodefault};
	__property TRectangleType RectangleType = {read=FRectangleType, write=FRectangleType, nodefault};
	__property TEllipseType EllipseType = {read=FEllipseType, write=FEllipseType, nodefault};
	
public:
	__fastcall virtual TSMRShape(Classes::TComponent* AOwner);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property TShapeStretch Stretch = {read=FStretch, write=FStretch, nodefault};
	__property TLineStyle LineStyle = {read=FLineStyle, write=FLineStyle, default=1};
public:
	#pragma option push -w-inl
	/* TSMRControl.Destroy */ inline __fastcall virtual ~TSMRShape(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRLine;
class PASCALIMPLEMENTATION TSMRLine : public TSMRShape 
{
	typedef TSMRShape inherited;
	
public:
	__fastcall virtual TSMRLine(Classes::TComponent* AOwner);
	
__published:
	__property LineType ;
public:
	#pragma option push -w-inl
	/* TSMRControl.Destroy */ inline __fastcall virtual ~TSMRLine(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRRectangle;
class PASCALIMPLEMENTATION TSMRRectangle : public TSMRShape 
{
	typedef TSMRShape inherited;
	
public:
	__fastcall virtual TSMRRectangle(Classes::TComponent* AOwner);
	
__published:
	__property RectangleType ;
public:
	#pragma option push -w-inl
	/* TSMRControl.Destroy */ inline __fastcall virtual ~TSMRRectangle(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMREllipse;
class PASCALIMPLEMENTATION TSMREllipse : public TSMRShape 
{
	typedef TSMRShape inherited;
	
public:
	__fastcall virtual TSMREllipse(Classes::TComponent* AOwner);
	
__published:
	__property EllipseType ;
public:
	#pragma option push -w-inl
	/* TSMRControl.Destroy */ inline __fastcall virtual ~TSMREllipse(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRImage;
class PASCALIMPLEMENTATION TSMRImage : public TSMRControl 
{
	typedef TSMRControl inherited;
	
private:
	AnsiString FExpression;
	Graphics::TPicture* FPicture;
	AnsiString FFileName;
	bool FStretch;
	bool FCenter;
	
public:
	__fastcall virtual TSMRImage(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRImage(void);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property bool Stretch = {read=FStretch, write=FStretch, nodefault};
	__property bool Center = {read=FCenter, write=FCenter, nodefault};
	__property AnsiString Expression = {read=FExpression, write=FExpression};
};


class DELPHICLASS TSMRichText;
class PASCALIMPLEMENTATION TSMRichText : public TSMRControl 
{
	typedef TSMRControl inherited;
	
private:
	AnsiString FExpression;
	Comctrls::TRichEdit* FRichEdit;
	AnsiString FFileName;
	bool FStretch;
	
public:
	__fastcall virtual TSMRichText(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRichText(void);
	virtual int __fastcall Draw(Graphics::TCanvas* ACanvas, Windows::TRect &ARect, int intBandHeight, Word 
		Flags);
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	
__published:
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property bool Stretch = {read=FStretch, write=FStretch, nodefault};
	__property AnsiString Expression = {read=FExpression, write=FExpression};
};


typedef void __fastcall (__closure *TDrawGridEvent)(System::TObject* Sender, const Windows::TRect &R
	);

class PASCALIMPLEMENTATION TSMRBand : public TSMRControl 
{
	typedef TSMRControl inherited;
	
private:
	TDrawGridEvent FOnDrawGrid;
	int FLinkedBand;
	TBandType FBandType;
	bool FStretch;
	bool FNewPage;
	bool FReprintHeader;
	double FLessThan;
	AnsiString FExpression;
	Db::TDataSet* FDataset;
	Db::TDataSet* __fastcall GetDataset(void);
	void __fastcall SetDataset(Db::TDataSet* Value);
	bool __fastcall GetIsGroup(void);
	
protected:
	virtual void __fastcall Paint(void);
	int __fastcall PrintBand(int intShift, int intBottom, Word Flags);
	DYNAMIC void __fastcall GetChildren(Classes::TGetChildProc Proc, Classes::TComponent* Root);
	virtual void __fastcall ReadState(Classes::TReader* Reader);
	DYNAMIC Classes::TComponent* __fastcall GetChildParent(void);
	DYNAMIC Classes::TComponent* __fastcall GetChildOwner(void);
	
public:
	Classes::TList* Objects;
	__fastcall virtual TSMRBand(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRBand(void);
	int __fastcall AddElement(TMetaClass* cntrlClass);
	int __fastcall GetElement(TSMRControl* smrControl);
	TMetaClass* __fastcall GetClassByName(AnsiString strClassName);
	void __fastcall DeleteAllElements(void);
	void __fastcall ChangeOrder(bool BringToFront);
	AnsiString __fastcall GetBandName();
	virtual bool __fastcall EditProperties(bool ShowPrevForm);
	__property TDrawGridEvent OnDrawGrid = {read=FOnDrawGrid, write=FOnDrawGrid};
	
__published:
	__property Db::TDataSet* Dataset = {read=GetDataset, write=SetDataset};
	__property bool IsGroup = {read=GetIsGroup, nodefault};
	__property int LinkedBand = {read=FLinkedBand, write=FLinkedBand, nodefault};
	__property TBandType BandType = {read=FBandType, write=FBandType, nodefault};
	__property bool Stretch = {read=FStretch, write=FStretch, nodefault};
	__property bool NewPage = {read=FNewPage, write=FNewPage, nodefault};
	__property bool ReprintHeader = {read=FReprintHeader, write=FReprintHeader, nodefault};
	__property double LessThan = {read=FLessThan, write=FLessThan};
	__property AnsiString Expression = {read=FExpression, write=FExpression};
};


struct TSMRRegisterControl;
typedef TSMRRegisterControl *PSMRRegisterControl;

struct TSMRRegisterControl
{
	AnsiString ControlClassName;
	int HintIndex;
	AnsiString Hint;
	int hInstance;
	int intCursorIndex;
} ;

//-- var, const, procedure ---------------------------------------------------
static const Shortint intPointHeight = 0x5;
extern PACKAGE Classes::TList* lstSMRControls;
extern PACKAGE void __fastcall DesignReport(TSMReport* AReport);
extern PACKAGE int __fastcall GetUnsignedCursor(void);
extern PACKAGE void __fastcall UpdateDesigner(Controls::TControl* ctrl, int intMessage, int WParam, 
	int LParam);
extern PACKAGE TSMRBand* __fastcall GetBandByControl(TSMRControl* cntr);
extern PACKAGE void __fastcall RegisterSMRControl(TMetaClass* ASMRControlClass, int AHintIndex, AnsiString 
	AHint, int AHInstance);
extern PACKAGE void __fastcall UnRegisterSMRControl(TMetaClass* ASMRControlClass);

}	/* namespace Smrbase */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smrbase;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMRBase
